const express = require('express'); //requires express module
const mongoose = require("mongoose");
const socket = require('socket.io'); //requires socket.io module
// Assuming you have a connection to the notification server
const notificationSocket = require('socket.io-client')('http://lizoapi.lizolive.online:3006');

const fs = require('fs');
var mysql = require('mysql');
var moment = require('moment');
const app = express();
var PORT = process.env.PORT || 1552;
const server = app.listen(PORT); //tells to host server on localhost:3000


//Playing variables:
app.use(express.static('public')); //show static files in 'public' directory

const User = require("./model/user.model");
const Payment = require("./model/payment.model");

const HorseRacingTable = require("./model/horseracing_table.model");
const HorseRacingBid = require("./model/horseracing_bid.model");
const AppSetting = require("./model/appSetting.model");

console.log('Server is running');
const io = socket(server, {
  cors: {
    origin: "*",
  }
});

mongoose.connect(
    `mongodb+srv://shakuniyaplayz:Lizo41586@lizolivecluster0.p5jyzri.mongodb.net/lizolive_prod`,

    {
        useNewUrlParser: true,
        useUnifiedTopology: true,
    }
);

const db = mongoose.connection;

db.on("error", console.error.bind(console, "connection error:"));
db.once("open", () => {
    console.log("MONGO: successfully connected to db");
});

var dbGameConnectionInfo = {
  host: "103.136.137.233",
  port: "3308",
  user: "sammy",
  password: "MN#5698#TY",
  database: "game_prod"
};

var conGame = mysql.createPool(
  dbGameConnectionInfo
);

conGame.on('connection', function (connection) {
  console.log('DB Connection established');
  connection.query("SET NAMES 'utf8mb4'")

  connection.on('error', function (err) {
    console.error(new Date(), 'MySQL error', err.code);
  });
  connection.on('close', function (err) {
    console.error(new Date(), 'MySQL close', err);
  });
});

var dbSkNotifyConnectionInfo = {
  host: "103.136.137.233",
  port: "3308",
  user: "sammy",
  password: "MN#5698#TY",
  database: "rageela_prod"
};

var conSkNotify = mysql.createPool(
  dbSkNotifyConnectionInfo
);

conSkNotify.on('connection', function (connection) {
  console.log('DB Connection established');
  connection.query("SET NAMES 'utf8mb4'")

  connection.on('error', function (err) {
    console.error(new Date(), 'MySQL error', err.code);
  });
  connection.on('close', function (err) {
    console.error(new Date(), 'MySQL close', err);
  });
});

let result = 0;
let seat_1 = 0;
let seat_2 = 0;
let seat_3 = 0;
let seat_4 = 0;
let seat_5 = 0;
let seat_6 = 0;
let actual_seat_1 = 0;
let actual_seat_2 = 0;
let actual_seat_3 = 0;
let actual_seat_4 = 0;
let actual_seat_5 = 0;
let actual_seat_6 = 0;

let winratio = 40;

let customRes = false;
let count = Math.floor(Date.now()/1000)-((Math.floor(Math.floor(Date.now()/1000)/30))*30);
let status = count < 20 ? 1 : (count < 25 ? 2 : 3);
let counter = count < 20 ? 20-count : (count < 25 ?  5-(count-20) : 5-(count-25));
let sessionId = (Math.floor(Math.floor(Date.now()/1000)/30));

const resultarrs = [3,1,2,5,3,2,4,2,4,1,2,3,4,2,2,5,1,2,1,1,4,1,2,3,1,3,1,4,1,5,3,1,2,1,1,6,5,1,1,3,2,4,2,3,2,1,3,1,5,1,4,3,5,2,3,2,5,1,4,5,1,4,5,3,4,2,1,2,6,2,4,1,3,5,3,1,4,1,2,3,1,1,2,1,4,2,1,2,4,2,1,2,1,1,4,3,4,3,1,4,2,1,4,3,4,5,2,5,2,2,2,2,5,3,4,1,2,3,5,1,1,1,1,3,5,4,5,6,2,5,4,2,1,2,1,1,2,1,4,1,3,5,1,5,3,5,2,1,5,1,3,1,2,4,3,2,3,1,4,1,4,3,1,3,1,1,3,5,2,1,3,4,1,5,2,3,2,1,3,1,2,2,4,3,2,1,3,5,1,2,4,3,1,1,1,3,4,3,2,1,4,2,5,2,3,2,3,6,1,5,1,4,1,5,4,5,3,2,2,3,2,4,1,4,1,3,4,3,4,1,2,1,2,5,3,1,4,6,1,5,1,4,1,5,4,2,1,4,5,1,2,1,5,2,1,2,1,4,2,1,1,1,1,2,1,1,2,1,2,2,1,2,6,2,2,4,5,2,3,2,5,1,3,2,5,3,1,2,4,5,3,2,1,2,5,1,5,1,4,1,1,4,3,1,5,2,4,5,2,3,1,5,1,3,2,1,5,2,1,1,1,6,4,2,3,5,1,1,3,5,1,1,4,1,2,4,3,4,3,1,1,3,1,4,1,4,1,4,3,1,4,3,4,1,2,1,1,1,4,1,2,4,2,3,2,3,4,3,1,2,1,5,2,1,1,2,2,5,2,2,6,2,5,3,4,2,1,2,5,1,5,4,2,2,6,3,1,4,2,1,2,2,5,1,5,2,5,2,5,2,3,5,2,5,2,3,5,1,4,2,1,2,1,4,1,2,3,1,4,3,1,3,1,1,4,1,3,4,3,4,1,4,3,1,1,1,1,4,3,1,4,1,1,1,4,1,4,1,3,4,3,1,3,1,3,1,2,3,4,2,4,1,4,1,2,3,2,4,6,2,3,2,1,4,3,5,1,1,5,1,5,3,2,1,2,1,2,2,4,5,1,4,1,2,1,2,5,3,2,2,3,1,1,2,1,1,2,6,5,4,1,2,1,1,4,5,1,3,5,1,1,3,1,1,5,4,1,4,2,3,5,1,1,2,1,5,3,1,5,3,4,2,3,1,1,4,2,3,2,4,3,1,3,1,4,1,6,1,2,1,2,3,5,3,1,5,2,1,4,1,4,1,4,2,1,1,2,1,2,1,4,3,2,3,1,2,5,1,4,1,2,1,1,1,5,2,3,1,3,1,2,1,1,1,5,2,3,1,2,4,1,3,4,6,1,2,4,2,1,3,2,5,2,1,5,4,1,2,1,2,3,2,3,4,5,3,2,1,5,4,2,1,3,4,5,1,4,3,1,3,5,4,5,3,4,6,1,2,3,5,3,2,1,1,3,2,5,1,4,5,2,1,3,2,4,3,2,5,1,5,4,5,4,5,1,2,4,1,2,1,5,6,1,2,4,3,2,3,1,4,1,5,1,2,2,3,5,3,5,1,3,1,2,3,1,3,1,5,1,6,4,1,2,3,1,2,1,1,3,2,4,2,3,4,1,4,1,1,4,2,4,1,1,1,4,2,4,2,1,2,4,2,1,2,1,1,4,3,6,3,1,3,4,2,5,5,2,5,2,3,5,4,1,2,4,2,2,4,1,1,2,3,2,3,5,1,5,2,5,2,5,2,3,1,4,2,2,1,2,4,2,4,5,3,1,2,6,1,3,5,2,5,1,5,1,2,1,3,4,3,1,4,3,5,1,3,2,4,1,3,1,3,1,3,1,1,1,4,1,4,2,1,1,1,2,1,1,1,1,1,4,1,4,1,4,5,1,5,1,4,5,2,3,4,5,2,3,2,5,2,4,6,1,5,2,2,1,2,3,1,2,1,3,2,5,4,1,2,3,4,5,2,2,1,4,2,3,1,5,2,4,2,3,4,2,2,1,2,2,4,2,1,5,1,6,2,5,4,5,3,5,3,4,1,4,1,1,4,3,4,3,1,3,1,1,3,1,3,1,3,4,1,3,1,4,1,3,1,1,1,1,1,1,1,1,6,4,2,1,2,2,2,5,1,1,4,2,5,2,5,2,4,5,4,1,2,5,2,2,3,1,3,6,2,5,2,4,2,3,1,2,1,5,1,4,2,4,1,2,3,1,3,4,1,4,1,5,2,1,5,4,1,3,1,1,2,4,1,1,2,1,4,1,1,4,1,6,4,3,4,1,2,3,2,4,5,1,2,1,3,5,3,5,1,3,1,3,1,3,1,3,1,3,1,3,1,2,6,3,5,2,5,5,3,5,2,1,2,2,1,2,3,5,2,4,1,5,4,5,3,2,2,3,1,4,1,5,1,4,1,5,2,1,3,1,2,1,4,1,3,5,4,1,6,4,2,1,2,1,4,2,5,1,2,1,1,3,1,4,3,1,4,2,1,3,1,5,1,3,4,5,1,3,1,1,3,2,3,1,2,4,3,2,4,1,1,1,4,2,4,1,2,4,1,3,2,1,4,2,1,2,5,2,3,5,2,6,5,1,5,1,2,1,1,3,1,1,2,1,1,5,2,1,2,1,2,1,4,5,2,2,4,1,4,2,1,2,3,1,4,1,2,2,3,5,2,3,2,5,4,5,1,2,4,3,2,3,2,1,1,5,3,1,6,5,4,2,4,1,2,4,1,4,1,4,3,5,4,1,4,1,3,4,1,3,4,3,1,3,1,3,1,3,1,3,6,3,2,1,1,4,1,2,2,1,4,1,1,5,4,2,4,2,5,2,5,2,1,1,5,1,2,5,4,2,1,3,1,6,3,1,4,5,2,1,4,5,1,4,5,2,1,2,1,4,3,5,1,3,1,2,1,3,4,1,2,1,4,6,5,4,1,3,2,1,4,5,1,5,3,1,2,1,2,3,2,1,3,2,3,4,2,4,2,4,3,1,3,1,3,1,2,1,3,1,3,4,6,5,1,4,2,1,4,2,3,2,4,2,4,2,1,2,3,2,3,2,1,3,2,5,2,1,1,2,3,5,2,1,5,1,4,6,5,1,5,3,5,1,5,1,3,2,4,1,2,3,5,1,1,2,5,1,5,1,5,4,1,3,2,1,4,3,1,1,4,1,1,4,2,1,2,1,4,1,4,1,2,1,2,4,1,4,3,1,2,1,3,2,3,1,2,3,1,3,1,5,1,6,3,1,1,1,1,5,4,5,2,1,3,2,1,2,1,2,5,4,5,2,5,2,4,3,1,5,1,4,2,2,1,2,3,2,1,2,5,4,1,5,1,3,1,5,4,2,5,2,5,2,3,1,2,1,4,2,3,1,4,1,2,1,4,3,4,6,2,4,2,4,3,2,1,4,3,1,4,3,1,3,4,1,4,1,3,1,2,1,1,1,3,1,3,1,2,3,2,2,2,3,1,2,1,1,4,2,2,6,1,5,2,1,2,4,2,3,4,5,4,1,5,1,4,2,1,2,1,5,3,1,4,2,1,5,3,4,2,1,5,2,1,3,2,1,1,2,3,1,1,1,5,2,1,3,5,6,4,1,2,4,1,2,5,4,3,5,2,2,3,2,3,1,3,4,1,1,3,4,5,4,1,5,4,1,4,2,3,1,1,1,3,1,3,4,3,1,1,3,2,1,1,2,3,1,2,1,1,3,4,5,1,2,1,6,2,1,2,1,5,1,2,3,2,5,3,1,1,2,3,2,3,2,1,3,2,3,2,1,5,1,2,5,1,4,5,3,1,4,1,1,2,2,4,3,4,2,4,2,1,4,5,4,1,3,6,2,5,2,5,1,3,1,5,1,4,2,5,1,3,5,4,1,4,1,3,4,3,1,4,2,1,4,1,4,1,4,1,3,1,2,4,2,1,3,4,3,5,2,2,3,1,4,3,2,4,1,1,2,1,6,1,2,1,2,5,2,4,5,1,5,2,4,3,4,2,5,2,2,1,4,3,1,1,2,1,2,4,1,3,4,2,1,1,4,1,5,1,4,1,4,3,1,3,4,3,1,1,2,4,2,5,2,1,4,2,1,3,2,5,6,3,1,2,5,3,5,1,1,1,5,1,5,3,1,3,1,1,6,5,6,1,5,3,4,2,6,2,1,5,2,3,5,1,3,4,2,5,1,3,1,5,2,1,1,3,2,3,2,3,1,3,2,3,5,3,1,4,1,4,3,2,5,1,2,3,2,3,1,3,2,1,2,4,1,4,1,1,2,4,1,1,3,2,3,1,1,4,1,5,1,1,5,2,1,2,1,4,1,1,3,2,4,2,1,2,1,4,1,4,1,4,1,4,1,4,1,2,4,3,1,1,2,2,1,1,4,3,4,5,2,1,5,1,1,3,6,2,3,2,1,4,1,5,2,1,3,2,3,2,6,1,5,2,1,2,2,2,5,1,3,1,1,2,2,1,1,3,1,2,6,3,1,4,2,3,5,1,4,5,4,1,1,2,2,4,1,3,2,4,2,1,1,3,4,5,3,5,4,3,4,1,1,4,5,4,1,1,3,1,3,1,3,1,4,1,4,3,4,3,1,5,1,5,3,1,3,1,3,6,2,5,4,1,2,1,3,6,2,1,4,2,4,3,2,2,1,6,3,4,2,3,1,3,4,1,5,4,2,5,1,3,1,5,4,2,4,1,2,1,2,1,2,4,1,3,2,3,1,2,2,1,5,4,1,1,5,1,4,1,3,1,5,2,5,2,4,1,2,3,2,1,2,1,4,1,1,4,3,1,3,1,4,1,1,4,3,5,1,1,2,5,1,3,2,4,3,1,6,5,1,3,2,4,5,3,6,2,5,4,2,5,2,4,1,6,1,3,2,1,2,3,2,5,2,4,1,5,2,5,2,1,4,2,4,3,5,1,2,2,4,5,1,3,1,4,1,2,1,1,3,2,4,1,2,3,2,3,4,3,1,3,1,1,3,4,3,2,1,1,1,1,4,3,1,1,4,3,1,1,4,1,4,1,1,4,1,1,5,2,1,2,1,2,5,2,5,1,1,1,3,1,2,3,2,1,3,1,6,3,2,4,5,2,1,6,1,6,2,1,4,3,2,1,2,1,1,1,2,1,3,4,3,1,1,4,2,3,2,3,4,2,3,2,2,4,1,1,3,4,3,1,4,1,2,5,3,4,1,2,4,3,5,4,1,2,5,4,5,1,3,1,3,4,1,3,5,1,4,1,5,1,1,1,1,1,4,2,5,2,2,6,2,1,3,5,1,2,3,6,1,1,6,2,3,2,1,1,2,4,2,5,4,1,2,2,5,2,1,2,2,2,1,5,4,2,1,5,1,4,3,4,2,4,1,4,5,4,2,1,2,1,4,2,1,3,2,1,5,4,5,1,4,3,4,1,4,1,4,1,3,1,3,4,1,5,3,4,1,3,1,3,1,3,1,1,4,1,1,3,1,3,1,1,1,3,1,1,6,2,6,5,1,2,6,3,2,1,2,3,2,2,2,3,2,2,5,4,3,5,1,2,3,4,1,2,4,3,4,3,1,1,5,4,1,5,1,3,4,3,1,4,1,2,3,1,5,4,3,1,4,1,3,5,3,1,5,1,3,4,2,3,5,2,4,1,5,4,1,2,3,4,2,3,4,1,1,1,4,1,1,2,4,1,1,1,2,1,4,1,2,1,2,1,1,1,1,1,3,6,2,1,1,4,3,4,3,2,5,3,2,6,5,3,1,4,1,1,1,6,2,4,1,1,3,4,1,1,3,1,1,2,1,5,4,3,1,1,2,2,5,3,4,1,3,2,4,5,2,2,1,3,5,3,1,4,1,2,2,2,4,2,1,4,2,5,1,2,5,2,3,1,2,4,2,1,2,3,4,5,3,1,3,4,3,4,1,4,5,1,1,1,4,1,1,1,1,6,2,6,1,1,2,5,2,3,1,5,3,1,2,1,5,3,1,2,6,3,5,1,1,4,1,1,2,1,6,4,2,1,2,1,1,4,1,4,1,3,5,4,3,1,5,2,3,5,2,4,1,5,4,1,3,1,5,3,1,3,1,1,5,2,1,1,3,1,2,4,3,4,3,2,1,1,2,3,1,1,4,1,1,1,3,1,3,4,2,4,3,4,2,4,2,4,2,4,2,5,4,3,1,4,6,5,1,6,1,4,1,4,2,2,3,4,2,1,2,4,2,5,4,2,1,3,2,2,5,3,2,4,6,4,5,2,1,3,5,1,3,4,1,2,5,3,5,2,3,5,2,4,1,5,4,1,5,4,3,4,3,1,2,1,2,3,1,3,1,2,1,2,1,1,3,1,3,1,3,2,4,3,4,1,4,1,1,1,2,1,1,3,2,1,1,1,1,1,1,1,1,4,1,6,2,1,1,5,2,1,3,5,2,2,1,3,5,2,3,1,2,4,1,5,4,2,2,1,4,5,2,1,2,1,1,5,2,1,3,5,1,5,6,4,1,1,2,2,1,5,2,5,2,4,2,3,2,4,1,3,5,1,1,3,1,4,2,4,1,2,3,1,4,3,4,1,5,4,3,1,1,4,3,1,2,3,4,1,4,3,1,3,1,3,1,1,2,4,3,4,2,1,2,1,5,1,2,4,1,5,4,1,3,2,2,1,4,1,4,2,3,2,1,2,2,2,2,1,1,3,5,1,2,1,2,3,1,2,3,2,3,6,5,3,4,5,4,3,2,1,3,5,2,2,1,1,1,4,1,4,1,5,4,1,2,3,4,5,4,1,2,3,2,5,1,5,3,5,2,4,1,1,6,3,1,4,3,4,1,3,1,4,1,3,1,4,1,4,1,1,4,2,5,3,5,1,4,2,5,1,5,2,1,6,3,5,1,2,2,1,1,3,1,1,2,1,4,2,1,1,2,1,1,3,2,4,3,1,2,4,2,4,1,2,5,3,1,2,3,2,5,3,2,4,6,1,4,1,3,1,5,4,2,4,1,5,2,3,1,3,5,1,5,1,5,1,4,2,4,2,1,2,1,4,1,4,1,2,4,2,4,1,3,1,3,1,3,1,3,1,5,2,6,1,2,1,4,2,1,1,2,2,5,4,1,2,4,1,1,4,2,1,4,1,3,5,4,3,1,5,1,5,4,3,1,1,2,1,5,1,2,1,5,4,2,4,6,1,4,2,1,5,3,2,1,2,1,2,4,3,2,1,2,2,1,2,4,3,5,3,1,3,1,4,3,4,5,3,2,2,1,1,3,4,3,1,3,1,4,3,5,3,5,2,1,2,1,3,1,4,2,5,3,2,2,1,2,5,3,2,5,2,5,2,4,1,3,6,2,1,2,5,4,2,1,3,1,2,3,1,2,4,3,2,1,4,5,1,3,2,5,4,1,5,1,1,2,1,2,1,5,3,1,5,2,5,3,6,1,1,2,4,2,1,5,1,2,1,1,3,4,3,4,2,4,1,4,1,2,1,3,4,1,1,3,1,3,4,3,1,4,3,1,4,1,4,1,4,1,1,3,6,2,1,5,4,1,5,1,2,5,2,5,2,1,2,1,3,1,1,2,3,5,2,4,2,2,1,1,2,5,1,2,1,3,2,4,1,2,5,2,3,2,5,1,5,2,1,2,1,2,1,4,2,2,1,4,3,2,1,3,4,2,3,4,1,1,5,4,5,1,3,1,6,3,5,3,1,1,1,4,1,4,3,4,3,1,4,1,1,4,3,1,4,3,1,4,1,4,3,2,1,1,1,5,2,4,5,2,6,2,2,5,1,4,3,4,3,1,5,1,2,2,1,4,5,2,5,1,5,1,2,5,6,2,5,4,2,4,3,1,2,1,2,2,1,1,4,3,5,2,4,2,1,3,4,3,2,3,1,1,2,3,2,1,5,4,3,2,4,1,1,1,3,2,1,2,1,5,1,1,4,3,1,4,1,4,3,1,1,3,1,1,4,3,4,1,3,1,3,1,3,1,1,1,4,3,5,1,3,2,3,1,2,1,4,1,1,2,4,2,1,2,2,2,4,6,2,2,1,3,1,2,2,5,1,2,1,3,2,5,1,4,3,2,1,6,3,1,2,4,2,2,1,5,1,4,1,2,2,2,3,5,1,4,1,4,1,5,1,5,2,4,2,1,3,4,5,3,4,5,3,4,5,1,5,1,3,5,3,4,3,1,4,1,3,1,4,1,4,3,5,6,2,5,2,3,1,3,5,2,1,4,1,4,1,3,4,1,2,1,1,1,2,3,2,4,1,4,5,2,5,3,1,2,1,2,1,3,5,1,2,5,1,3,5,2,1,2,1,2,3,4,5,1,2,1,2,2,5,2,1,5,1,4,2,4,6,1,2,3,2,1,2,5,1,1,2,1,3,1,3,4,3,1,4,3,4,3,1,3,1,4,1,4,1,4,1,4,6,1,4,3,2,1,4,1,1,1,1,3,2,5,1,4,3,2,4,2,5,2,1,4,1,2,1,1,5,6,1,2,2,2,1];
//const resultarrs = [1,6,1,6,1,6,8,1,6,8,6,2,3,4,5,1];
//Socket.io Connection------------------
io.on('connection', async (socket) => {
    
    let userUid = 0;
    let userId = 0;
    let userName = "";
    let userImage = "";
    
    console.log("New socket connection: " + socket.id)
    socket.on('join', function (data) {    
        socket.join(data);
        userUid = data;
        console.log("join: "+userUid);
        if (userUid == 1614626426 ) {
            console.log("banned join: "+userUid);
            socket.disconnect(true);
        }
    });
    let history = [];
    const horseRacingHistory = await HorseRacingTable.aggregate([
        {
            $match: {
                session: { $lt: sessionId } // Replace with actual sessionId ObjectId
            }
        },
        {
            $sort: { session: -1 } // Sort by session in descending order
        },
        {
            $limit: 15 // Limit results to 15 documents
        },
        {
            $project: {
                result: 1, // Include only the "result" field
                session: 1 // Convert session ObjectId to string
            }
        }
    ]);

    for (const value of horseRacingHistory) {
        const index = horseRacingHistory.indexOf(value);
        history.push(value.result);
    }
    io.emit('history', {"history": history});
    
    socket.on('setResult', data => {
        if (status < 2) {
            result = data;
            customRes = true
            io.emit("setResultRes", result);
        }
    });
    
    let myBiddingSeat_1 = 0;
    let myBiddingSeat_2 = 0;
    let myBiddingSeat_3 = 0;
    let myBiddingSeat_4 = 0;
    let myBiddingSeat_5 = 0;
    let myBiddingSeat_6 = 0;
    let today = moment().startOf('day');
    const todayWinning = await Payment.aggregate([
        {
            $match: {
                userId: userUid, type: 556, isIncome: true, createdAt: {$gt: today.toDate()}
            }
        },
        {
            $group: {
                _id: "$userId",
                winBidAmt: {
                    $sum: "$coin"
                }
            }
        }
    ]);
    if (todayWinning.length > 0) {
        console.log('todayWinning',todayWinning);
        io.emit('myWinning', todayWinning[0].winBidAmt);
    }
    let oldOwnStatus = 0;
    let notBet = true;
    var t=setInterval(async function () {
        sessionId = (Math.floor(Math.floor(Date.now()/1000)/30));
        vsessionId = Math.floor((Math.floor(Date.now()/1000)-(Math.floor(Math.floor(Date.now()/1000)/86400)*86400))/30);
        count = Math.floor(Date.now()/1000)-((Math.floor(Math.floor(Date.now()/1000)/30))*30);
        const Ownstatus = count < 20 ? 1 : (count < 25 ? 2 : 3);
        if (oldOwnStatus != Ownstatus) {
            io.emit('roundChange', vsessionId);
        }
        if (oldOwnStatus != Ownstatus && Ownstatus == 1) {
            notBet = true;
            myBiddingSeat_1 = 0;
            myBiddingSeat_2 = 0;
            myBiddingSeat_3 = 0;
            myBiddingSeat_4 = 0;
            myBiddingSeat_5 = 0;
            myBiddingSeat_6 = 0;
            
            let today = moment().startOf('day');
            const todayWinning = await Payment.aggregate([
                {
                    $match: {
                        userId: userUid, isIncome: true, type: 556, createdAt: {$gt: today.toDate()}
                    }
                },
                {
                    $group: {
                        _id: "$userId",
                        winBidAmt: {
                            $sum: "$coin"
                        }
                    }
                }
            ]);
            if (todayWinning.length > 0) {
                io.emit('myWinning', todayWinning[0].winBidAmt);
            }
        }
//        if (oldOwnStatus != Ownstatus && Ownstatus == 2 && notBet) {
        if (Ownstatus == 1 && count > 15 && notBet) {
            notBet = false;
            console.log('status change', 'oldStatus', oldOwnStatus,'newStatus',Ownstatus);
            const totalBids = myBiddingSeat_1+myBiddingSeat_2+myBiddingSeat_3+myBiddingSeat_4+myBiddingSeat_5+myBiddingSeat_6;
            console.log('totalBids',totalBids);
            if (totalBids > 0) {
                console.log(totalBids);
                const user = await User.findOne({uid: userUid});
                if (user) {
                    if (user.balance >= totalBids) {
                        await User.updateOne({uid: userUid},{ $inc: { balance: -totalBids } });
                        const paymentBidding = new Payment();
                        paymentBidding.userId = userUid;
                        paymentBidding.coin = totalBids;
                        paymentBidding.type = 556
                        paymentBidding.isIncome = false;
                        paymentBidding.date = new Date().toLocaleString();
                        paymentBidding.save();
                        
                        const companyShare = (totalBids)*0.5;
                        const rotationShare = (totalBids)*0.5;
                        const companyBalance = await AppSetting.findOne({ name: 'horse_company'});
                        companyBalance.valueInt = companyBalance.valueInt+companyShare;
                        await companyBalance.save();
                        
                        if (myBiddingSeat_1 > 0) {
                            const horseRacingBid = new HorseRacingBid();
                            horseRacingBid.uid = userUid;
                            horseRacingBid.name = userName;
                            horseRacingBid.image = userImage;
                            horseRacingBid.session = sessionId;
                            horseRacingBid.vsession = vsessionId;
                            horseRacingBid.amount = myBiddingSeat_1;
                            horseRacingBid.seat = 1;
                            horseRacingBid.save();
                            console.log(Math.floor(Date.now() / 1000),' seat 1 bid added for '+userName+' Amount: '+myBiddingSeat_1)
                        }
                        if (myBiddingSeat_2 > 0) {
                            const horseRacingBid = new HorseRacingBid();
                            horseRacingBid.uid = userUid;
                            horseRacingBid.name = userName;
                            horseRacingBid.image = userImage;
                            horseRacingBid.session = sessionId;
                            horseRacingBid.vsession = vsessionId;
                            horseRacingBid.amount = myBiddingSeat_2;
                            horseRacingBid.seat = 2;
                            horseRacingBid.save();
                            console.log(Math.floor(Date.now() / 1000),' seat 2 bid added for '+userName+' Amount: '+myBiddingSeat_2)
                        }
                        if (myBiddingSeat_3 > 0) {
                            const horseRacingBid = new HorseRacingBid();
                            horseRacingBid.uid = userUid;
                            horseRacingBid.name = userName;
                            horseRacingBid.image = userImage;
                            horseRacingBid.session = sessionId;
                            horseRacingBid.vsession = vsessionId;
                            horseRacingBid.amount = myBiddingSeat_3;
                            horseRacingBid.seat = 3;
                            horseRacingBid.save();
                            console.log(Math.floor(Date.now() / 1000),' seat 3 bid added for '+userName+' Amount: '+myBiddingSeat_3)
                        }
                        if (myBiddingSeat_4 > 0) {
                            const horseRacingBid = new HorseRacingBid();
                            horseRacingBid.uid = userUid;
                            horseRacingBid.name = userName;
                            horseRacingBid.image = userImage;
                            horseRacingBid.session = sessionId;
                            horseRacingBid.vsession = vsessionId;
                            horseRacingBid.amount = myBiddingSeat_4;
                            horseRacingBid.seat = 4;
                            horseRacingBid.save();
                            console.log(Math.floor(Date.now() / 1000),' seat 4 bid added for '+userName+' Amount: '+myBiddingSeat_4)
                        }
                        if (myBiddingSeat_5 > 0) {
                            const horseRacingBid = new HorseRacingBid();
                            horseRacingBid.uid = userUid;
                            horseRacingBid.name = userName;
                            horseRacingBid.image = userImage;
                            horseRacingBid.session = sessionId;
                            horseRacingBid.vsession = vsessionId;
                            horseRacingBid.amount = myBiddingSeat_5;
                            horseRacingBid.seat = 5;
                            horseRacingBid.save();
                            console.log(Math.floor(Date.now() / 1000),' seat 5 bid added for '+userName+' Amount: '+myBiddingSeat_5)
                        }
                        if (myBiddingSeat_6 > 0) {
                            const horseRacingBid = new HorseRacingBid();
                            horseRacingBid.uid = userUid;
                            horseRacingBid.name = userName;
                            horseRacingBid.image = userImage;
                            horseRacingBid.session = sessionId;
                            horseRacingBid.vsession = vsessionId;
                            horseRacingBid.amount = myBiddingSeat_6;
                            horseRacingBid.seat = 6;
                            horseRacingBid.save();
                            console.log(Math.floor(Date.now() / 1000),' seat 6 bid added for '+userName+' Amount: '+myBiddingSeat_6)
                        }
                        
                        await HorseRacingTable.updateOne({session: sessionId},{ $inc: { seat_1: myBiddingSeat_1 } });
                        console.log('updateOne', {session: sessionId},{ $inc: { seat_1: myBiddingSeat_1 } })
                        await HorseRacingTable.updateOne({session: sessionId},{ $inc: { seat_2: myBiddingSeat_2 } });
                        console.log('updateOne', {session: sessionId},{ $inc: { seat_2: myBiddingSeat_2 } })
                        await HorseRacingTable.updateOne({session: sessionId},{ $inc: { seat_3: myBiddingSeat_3 } });
                        console.log('updateOne', {session: sessionId},{ $inc: { seat_3: myBiddingSeat_3 } })
                        await HorseRacingTable.updateOne({session: sessionId},{ $inc: { seat_4: myBiddingSeat_4 } });
                        console.log('updateOne', {session: sessionId},{ $inc: { seat_4: myBiddingSeat_4 } })
                        await HorseRacingTable.updateOne({session: sessionId},{ $inc: { seat_5: myBiddingSeat_5 } });
                        console.log('updateOne', {session: sessionId},{ $inc: { seat_5: myBiddingSeat_5 } })
                        await HorseRacingTable.updateOne({session: sessionId},{ $inc: { seat_6: myBiddingSeat_6 } });
                        console.log('updateOne', {session: sessionId},{ $inc: { seat_6: myBiddingSeat_6 } })
                    }
                }
            }
        }
        oldOwnStatus = Ownstatus;
    },1000);
    socket.on("disconnect", async () => {
        myBiddingSeat_1 = 0;
        myBiddingSeat_2 = 0;
        myBiddingSeat_3 = 0;
        myBiddingSeat_4 = 0;
        myBiddingSeat_5 = 0;
        myBiddingSeat_6 = 0;
    });
    socket.on('bid', async (data) => {
        if (status == 1) {
            const response = JSON.parse(data);
            const bidder = response.uid;
            const bidderId = response.id;
            const amount = response.selectedBidding;
            const seat = response.seat;
            const user = await User.findOne({uid: bidder});
            if (user) {
                if (user.balance >= amount) {
                    userUid = user.uid
                    userName = user.fullname
                    userImage = user.image
                    if (seat == 1) {
                        seat_1 = seat_1+amount
                        actual_seat_1 = actual_seat_1+amount
                        myBiddingSeat_1 = myBiddingSeat_1+amount
                    }
                    else if (seat == 2) {
                        seat_2 = seat_2+amount
                        actual_seat_2 = actual_seat_2+amount
                        myBiddingSeat_2 = myBiddingSeat_2+amount
                    }
                    else if (seat == 3) {
                        seat_3 = seat_3+amount
                        actual_seat_3 = actual_seat_3+amount
                        myBiddingSeat_3 = myBiddingSeat_3+amount
                    }
                    else if (seat == 4) {
                        seat_4 = seat_4+amount
                        actual_seat_4 = actual_seat_4+amount
                        myBiddingSeat_4 = myBiddingSeat_4+amount
                    }
                    else if (seat == 5) {
                        seat_5 = seat_5+amount
                        actual_seat_5 = actual_seat_5+amount
                        myBiddingSeat_5 = myBiddingSeat_5+amount
                    }
                    else if (seat == 6) {
                        seat_6 = seat_6+amount
                        actual_seat_6 = actual_seat_6+amount
                        myBiddingSeat_6 = myBiddingSeat_6+amount
                    }
                    console.log(Math.floor(Date.now() / 1000),data)
                    console.log(bidder);
                    console.log(bidderId);
                    console.log(amount);
                    console.log(seat);
                    io.emit('sinbid', {"seat": seat,"amount": amount});
                    io.emit('bidding', {"bidder": 0,"seat_1": seat_1,"seat_2": seat_2,"seat_3": seat_3,"seat_4": seat_4,"seat_5": seat_5,"seat_6": seat_6,"actual_seat_1": actual_seat_1,"actual_seat_2": actual_seat_2,"actual_seat_3": actual_seat_3,"actual_seat_4": actual_seat_4,"actual_seat_5": actual_seat_5,"actual_seat_6": actual_seat_6});
                };
            };
        }
    })
})

var t=setInterval(async function () {
    const oldStatus = status;
    sessionId = (Math.floor(Math.floor(Date.now()/1000)/30));
    vsessionId = (Math.floor(Math.floor(Date.now()/1000)-(Math.floor(Math.floor(Date.now()/1000)/86400))/30));
    count = Math.floor(Date.now()/1000)-((Math.floor(Math.floor(Date.now()/1000)/30))*30);
    status = count < 20 ? 1 : (count < 25 ? 2 : 3);
    counter = count < 20 ? 20-count : (count < 25 ?  5-(count-20) : 5-(count-25));
    if (status == 1) {
        seat = Math.floor(1 + Math.random()*(6 - 1 + 1));
        amount = Math.floor(1 + Math.random()*(100 - 1 + 1))*10;
        if (seat == 1) {
            seat_1 = seat_1+amount
        }
        else if (seat == 2) {
            seat_2 = seat_2+amount
        }
        else if (seat == 3) {
            seat_3 = seat_3+amount
        }
        else if (seat == 4) {
            seat_4 = seat_4+amount
        }
        else if (seat == 5) {
            seat_5 = seat_5+amount
        }
        else if (seat == 6) {
            seat_6 = seat_6+amount
        }
        io.emit('sinbid', {"seat": seat,"amount": amount});
        io.emit('bidding', {"bidder": 1,"seat_1": seat_1,"seat_2": seat_2,"seat_3": seat_3,"seat_4": seat_4,"seat_5": seat_5,"seat_6": seat_6,"actual_seat_1": actual_seat_1,"actual_seat_2": actual_seat_2,"actual_seat_3": actual_seat_3,"actual_seat_4": actual_seat_4,"actual_seat_5": actual_seat_5,"actual_seat_6": actual_seat_6});
    }
    if (oldStatus == 3 && status == 1) {
        customRes = false
        result = 0;
        seat_1 = 0;
        seat_2 = 0;
        seat_3 = 0;
        seat_4 = 0;
        seat_5 = 0;
        seat_6 = 0;
        actual_seat_1 = 0;
        actual_seat_2 = 0;
        actual_seat_3 = 0;
        actual_seat_4 = 0;
        actual_seat_5 = 0;
        actual_seat_6 = 0;
        io.emit('bidding', {"bidder": 0,"seat_1": seat_1,"seat_2": seat_2,"seat_3": seat_3,"seat_4": seat_4,"seat_5": seat_5,"seat_6": seat_6,"actual_seat_1": actual_seat_1,"actual_seat_2": actual_seat_2,"actual_seat_3": actual_seat_3,"actual_seat_4": actual_seat_4,"actual_seat_5": actual_seat_5,"actual_seat_6": actual_seat_6});
        io.emit('bidding', {"bidder": 1,"seat_1": seat_1,"seat_2": seat_2,"seat_3": seat_3,"seat_4": seat_4,"seat_5": seat_5,"seat_6": seat_6,"actual_seat_1": actual_seat_1,"actual_seat_2": actual_seat_2,"actual_seat_3": actual_seat_3,"actual_seat_4": actual_seat_4,"actual_seat_5": actual_seat_5,"actual_seat_6": actual_seat_6});
        const newHorseRacingTable = new HorseRacingTable();
        newHorseRacingTable.session = sessionId;
        newHorseRacingTable.result = 1;
        newHorseRacingTable.seat_1 = 0;
        newHorseRacingTable.seat_2 = 0;
        newHorseRacingTable.seat_3 = 0;
        await newHorseRacingTable.save();
        
        let history = [];
        const horseRacingHistory = await HorseRacingTable.aggregate([
            {
                $match: {
                    session: { $lt: sessionId } // Replace with actual sessionId ObjectId
                }
            },
            {
                $sort: { session: -1 } // Sort by session in descending order
            },
            {
                $limit: 15 // Limit results to 15 documents
            },
            {
                $project: {
                    result: 1, // Include only the "result" field
                    session: 1 // Convert session ObjectId to string
                }
            }
        ]);

        for (const value of horseRacingHistory) {
            const index = horseRacingHistory.indexOf(value);
            history.push(value.result);
        }
        io.emit('history', {"history": history});
        if (result == 0) {
            result = Math.floor(1 + Math.random()*(6 - 1 + 1));
            io.emit("setResultRes", result);
        }
        
    }
    if (oldStatus == 1 && status == 2) {
        let top3 = [];
        const horseRacingTopBidding = await HorseRacingBid.aggregate([
            {
                $match: {
                    session: sessionId,
                    seat: result
                }
            },
            {
                $group: {
                    _id: "$uid",
                    uid: { $first:"$uid" },
                    name: { $first:"$name" },
                    image: { $first:"$image" },
                    bidAmt: { $sum: "$amount" },
                    winBidAmt: {
                        $sum: {
                            $cond: {
                                if: { $and: [ { $eq: [ "$seat", result ] } ] },
                                then: "$amount",
                                else: 0
                            }
                        }
                    }
                }
            },
            {
                $sort: { winBidAmt: -1 }
            },
            {
                $limit: 3
            }
        ]);
        console.log('horseRacingTopBidding');
        console.log(JSON.stringify([
            {
                $match: {
                    session: sessionId,
                    seat: result
                }
            },
            {
                $group: {
                    _id: "$uid",
                    uid: { $first:"$uid" },
                    name: { $first:"$name" },
                    bidAmt: { $sum: "$amount" },
                    winBidAmt: {
                        $sum: {
                            $cond: {
                                if: { $and: [ { $eq: [ "$seat", result ] } ] },
                                then: "$amount",
                                else: 0
                            }
                        }
                    }
                }
            },
            {
                $sort: { winBidAmt: -1 }
            },
            {
                $limit: 3
            }
        ]));
        console.log(horseRacingTopBidding)
        for (const value of horseRacingTopBidding) {
            const index = horseRacingTopBidding.indexOf(value);
            const factors = [2, 4, 6, 14, 28, 50];
            top3.push({uid: value.uid, image: value.image, name: value.name, bid: value.bidAmt, win: (value.winBidAmt*factors[result-1])-Math.floor((value.winBidAmt*factors[result-1])/25)});
        }
        if (top3.length === 0) {
            top3.push({uid: 0, name: '', image: '', bid: 0, win: 0});
            top3.push({uid: 0, name: '', image: '', bid: 0, win: 0});
            top3.push({uid: 0, name: '', image: '', bid: 0, win: 0});
        }
        else if (top3.length === 1) {
            top3.push({uid: 0, name: '', image: '', bid: 0, win: 0});
            top3.push({uid: 0, name: '', image: '', bid: 0, win: 0});
        }
        else if (top3.length === 2) {
            top3.push({uid: 0, name: '', image: '', bid: 0, win: 0});
        }
        console.log('result', {result: result, highscores: top3});
        io.emit('result', {result: result, highscores: top3});
        let totalbids = actual_seat_1+actual_seat_2+actual_seat_3+actual_seat_4+actual_seat_5+actual_seat_6;
        let totalwin = 0;
        if (result == 1) {
            totalwin = actual_seat_1;
        } else if (result == 2) {
            totalwin = actual_seat_2;
        } else if (result == 3) {
            totalwin = actual_seat_3;
        } else if (result == 4) {
            totalwin = actual_seat_4;
        } else if (result == 5) {
            totalwin = actual_seat_5;
        } else if (result == 6) {
            totalwin = actual_seat_6;
        }
        const factors = [2, 4, 6, 14, 28, 50];
    }
    if (oldStatus == 2 && status == 3) {
        console.log(Date.now(),"state result");

        await HorseRacingTable.updateOne({session: sessionId},{ $set: { result: result } });

        const HorseRacingBidding = await HorseRacingBid.aggregate([
            {
                $match: {
                    session: sessionId
                }
            },
            {
                $group: {
                    _id: "$uid",
                    uid: { $first:"$uid" },
                    name: { $first:"$name" },
                    image: { $first:"$image" },
                    bidAmt: { $sum: "$amount" },
                    winBidAmt: {
                        $sum: {
                            $cond: {
                                if: { $and: [ { $eq: [ "$seat", result ] } ] },
                                then: "$amount",
                                else: 0
                            }
                        }
                    }
                }
            },
            {
                $sort: {bidAmt: -1}
            }
        ]);
        
        for (const value of HorseRacingBidding) {
            console.log('biddings result',value)
            const index = HorseRacingBidding.indexOf(value);
            const factors = [2, 4, 6, 14, 28, 50];
            const winning = (value.winBidAmt*factors[result-1])-Math.floor((value.winBidAmt*factors[result-1])/25);
            io.emit('myresult', {uid: value.uid, bid: value.bidAmt, win: winning});
            
            if (winning > 0) {
                await User.updateOne({uid: value.uid},{ $inc: { balance: winning } });
                const paymentWinning = new Payment();
                paymentWinning.userId = value.uid;
                paymentWinning.coin = winning;
                paymentWinning.type = 556
                paymentWinning.isIncome = true;
                paymentWinning.date = new Date().toLocaleString();
                paymentWinning.save();
                const premiumMessage = value.name+" won "+winning+" Coins!";
                notificationSocket.emit('game_notification', {gameType: 2,message: premiumMessage});
            }
        }
    }
    io.emit('counter', counter);
    if (counter <= 5 && status != 3) {
        if (status == 1 && !customRes) {
            customRes = true;
            console.log(" round Roll: "+sessionId % resultarrs.length);
            //result = resultarrs[sessionId % resultarrs.length];
            //io.emit("setResultRes", result);
            const rotationBalance = await AppSetting.findOne({ name: 'horse_rotation'});
            const totalBids = actual_seat_1+actual_seat_2+actual_seat_3+actual_seat_4+actual_seat_5+actual_seat_6;
            let rotationShare = Math.floor(totalBids*0.5);
            console.log('rotationShare',rotationShare);
            let maxReward = Math.floor(rotationShare * 3);
            rotationBalance.valueInt = rotationBalance.valueInt+rotationShare;
            if (maxReward > rotationBalance.valueInt+rotationShare) {
                maxReward = rotationBalance.valueInt+rotationShare;
            }
            console.log('maxReward',maxReward);
            const array = [actual_seat_1*2,actual_seat_2*4,actual_seat_3*6,actual_seat_4*14,actual_seat_5*28,actual_seat_6*50];
            let suitvals = [];
            array.forEach((item, index, arr) => {
                console.log(item,index,arr)
                if (item < maxReward) {
                    suitvals.push(index+1);
                }
            });
            console.log('suitvals',suitvals);
            if (suitvals.length > 0) {
                result = suitvals[Math.floor(Math.random()*(suitvals.length))];
                console.log('final result suit', result);
                io.emit("setResultRes", result);
            }
            else {
                let largest = array[0];
                let largestIndex = 1;
                array.forEach((item, index, arr) => {
                    console.log(item,index,arr)
                    if (item < largest) {
                        largest = item;
                        largestIndex = index+1;
                        result = largestIndex;;
                    }
                });
                console.log('final result random', result);
                io.emit("setResultRes", result)
            }
            rotationBalance.valueInt = rotationBalance.valueInt-array[result-1];
            console.log('add reward',rotationBalance.valueInt)
            await rotationBalance.save();
        }
        io.emit('status', status);
    }
    else {
        io.emit('status', status);
    }
},1000);